// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"github.com/oracle/oci-go-sdk/v56/common"
)

// HostCisBenchmarkScanResultScore A single CIS (Center for Internet Security) benchmark executed in a host scan
type HostCisBenchmarkScanResultScore struct {

	// Identifier for this CIS (Center for Internet Security) benchmark
	BenchmarkIdentifier *string `mandatory:"true" json:"benchmarkIdentifier"`

	// Details about what this CIS (Center for Internet Security) benchmark represents
	Description *string `mandatory:"true" json:"description"`

	// Result score of CIS (Center for Internet Security) benchmark execution (Pass/Fail)
	Score ScanResultScoreEnum `mandatory:"true" json:"score"`
}

func (m HostCisBenchmarkScanResultScore) String() string {
	return common.PointerString(m)
}
