// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

import (
	"encoding/json"
	"github.com/oracle/oci-go-sdk/v56/common"
)

// HostScanAgentConfigurationOci Agent configuration options for the OCI host scan agent
type HostScanAgentConfigurationOci struct {
	CisBenchmarkSettings *HostCisBenchmarkSettings `mandatory:"false" json:"cisBenchmarkSettings"`

	EndpointProtectionSettings *HostEndpointProtectionSettings `mandatory:"false" json:"endpointProtectionSettings"`
}

func (m HostScanAgentConfigurationOci) String() string {
	return common.PointerString(m)
}

// MarshalJSON marshals to json representation
func (m HostScanAgentConfigurationOci) MarshalJSON() (buff []byte, e error) {
	type MarshalTypeHostScanAgentConfigurationOci HostScanAgentConfigurationOci
	s := struct {
		DiscriminatorParam string `json:"vendor"`
		MarshalTypeHostScanAgentConfigurationOci
	}{
		"OCI",
		(MarshalTypeHostScanAgentConfigurationOci)(m),
	}

	return json.Marshal(&s)
}
