// Copyright (c) 2016, 2018, 2022, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Scanning API
//
// Use the Vulnerability Scanning Service (VSS) APIs to manage scan recipes, targets, and reports.
//

package vulnerabilityscanning

// VulnerabilityTypeEnum Enum with underlying type: string
type VulnerabilityTypeEnum string

// Set of constants representing the allowable values for VulnerabilityTypeEnum
const (
	VulnerabilityTypeCve     VulnerabilityTypeEnum = "CVE"
	VulnerabilityTypeProblem VulnerabilityTypeEnum = "PROBLEM"
)

var mappingVulnerabilityType = map[string]VulnerabilityTypeEnum{
	"CVE":     VulnerabilityTypeCve,
	"PROBLEM": VulnerabilityTypeProblem,
}

// GetVulnerabilityTypeEnumValues Enumerates the set of values for VulnerabilityTypeEnum
func GetVulnerabilityTypeEnumValues() []VulnerabilityTypeEnum {
	values := make([]VulnerabilityTypeEnum, 0)
	for _, v := range mappingVulnerabilityType {
		values = append(values, v)
	}
	return values
}
